using Base.Test

include("main.jl")

testdir = "tests_"*string(now())
mkdir(testdir)
include("logging.jl")
logger=setup_logging(joinpath(testdir, "tests.log"))
info(testdir)

cd(testdir)

# groupname = name(G)
# ub = PARSEDARGS["upper-bound"]
#
# fullpath = joinpath(groupname, string(ub))
# isdir(fullpath) || mkpath(fullpath)

separator(n=60) = info("\n"*("\n"*"="^n*"\n"^3)*"\n")


function SL_tests(args)


    args["SL"] = 2
    args["p"] = 3
    G = PropertyTGroup(args)
    @test main(G) == true
    separator()

    let args = args
        args["SL"] = 2
        args["p"] = 5
        G = PropertyTGroup(args)
        @test main(G) == false
        separator()

        args["warmstart"] = true
        G = PropertyTGroup(args)
        @test main(G) == false
        separator()

        args["upper-bound"] = 0.1
        G = PropertyTGroup(args)
        @test main(G) == true
        separator()
    end

    args["SL"] = 2
    args["p"] = 7
    G = PropertyTGroup(args)
    @test main(G) == false
    separator()

    args["SL"] = 3
    args["p"] = 7
    G = PropertyTGroup(args)
    @test main(G) == true
    separator()

    # begin
    #     args["iterations"] = 25000
    #     args["N"] = 3
    #     args["p"] = 0
    #     args["upper-bound"] = Inf
    #
    #     G = PropertyTGroups.SpecialLinearGroup(args)
    #     @test main(G) == false
    #     separator()
    #
	#     args["warmstart"] = false
    #     args["upper-bound"] = 0.27
    #     G = PropertyTGroups.SpecialLinearGroup(args)
    #     @test main(G) == false
    #     separator()
    #
    #     args["warmstart"] = true
    #     G = PropertyTGroups.SpecialLinearGroup(args)
    #     @test main(G) == true
    #     separator()
    # end

    return 0
end

function SAut_tests(args)

    G = PropertyTGroup(args)
    @test main(G) == false
    separator()

    args["warmstart"] = true
    G = PropertyTGroup(args)
    @test main(G) == false
    separator()

    args["upper-bound"] = 0.1
    G = PropertyTGroup(args)
    @test main(G) == false
    separator()

    return 0
end

@testset "Groups with(out) (T)" begin

    @testset "GAPGroups" begin
        args = Dict(
            "Higman" => true,
            "iterations"=>5000,
            "tol"=>1e-7,
            "upper-bound"=>Inf,
            "cpus"=>2,
            "radius"=>2,
            "warmstart"=>false,
            "nosymmetry"=>true,
        )

        G = PropertyTGroup(args)
        @test main(G) == false

        args = Dict(
            "Caprace" => true,
            "iterations"=>5000,
            "tol"=>1e-7,
            "upper-bound"=>Inf,
            "cpus"=>2,
            "radius"=>2,
            "warmstart"=>false,
            "nosymmetry"=>true,
        )

        G = PropertyTGroup(args)
        @test main(G) == false

        args = Dict(
            "MCG" => 3,
            "iterations"=>5000,
            "tol"=>1e-7,
            "upper-bound"=>Inf,
            "cpus"=>2,
            "radius"=>2,
            "warmstart"=>false,
            "nosymmetry"=>true,
        )

        G = PropertyTGroup(args)
        @test main(G) == false
    end

    @testset "SLn's" begin
        @testset "Non-Symmetrized" begin

            args = Dict(
                "SL" => 2,
                "p" => 3,
                "X" => false,
                "iterations"=>50000,
                "tol"=>1e-7,
                "upper-bound"=>Inf,
                "cpus"=>2,
                "radius"=>2,
                "warmstart"=>false,
                "nosymmetry"=>true,
            )

            SL_tests(args)
        end

        @testset "Symmetrized" begin

            args = Dict(
                "SL" => 2,
                "p" => 3,
                "X" => false,
                "iterations"=>20000,
                "tol"=>1e-7,
                "upper-bound"=>Inf,
                "cpus"=>2,
                "radius"=>2,
                "warmstart"=>false,
                "nosymmetry"=>false,
            )

            SL_tests(args)
        end
    end

    @testset "SAutF_n's" begin

        @testset "Non-Symmetrized" begin

            args = Dict(
                "SAut" => 2,
                "iterations"=>5000,
                "tol"=>1e-7,
                "upper-bound"=>Inf,
                "cpus"=>2,
                "radius"=>2,
                "warmstart"=>false,
                "nosymmetry"=>true,
            )
            SAut_tests(args)
        end

        @testset "Symmetrized" begin
            args = Dict(
                "SAut" => 3,
                "iterations"=>500,
                "tol"=>1e-7,
                "upper-bound"=>Inf,
                "cpus"=>2,
                "radius"=>2,
                "warmstart"=>false,
                "nosymmetry"=>false,
            )
            SAut_tests(args)
        end
    end


end
